gopher.sh: note the current link number
[gofetch.git] / gopher.sh
index 3e9a26411cf6ec72bc0038c7eb96f830dc668bf1..58175702600c07be27fe6f97fddb896273c14163 100755 (executable)
--- a/gopher.sh
+++ b/gopher.sh
 #              ...
 #              download: fake mode to download the result without changes
 
+# Manual:
+#      When asked for a number (non-dialog uses only), you can also
+#      enter 'n' or 'p' to get the next or previous item (+1 or -1)
+
 # ENV variables:
 #      USE_DIALOG: force the usage of the command 'dialog'
 #                : true if dialog is found
 #              1 : means colour 1
 #              2 : means colour 2
 #              [...]
+#      INVERT    : invert the output for image viewing (for white backgrounds)
+#              0 : do not invert (default)
+#              1 : invert 
+
+# EXIT Codes:
+#        0: ok
+#        1: syntax error
+#        2: cannot contact server
+#        3: unknown selector mode
+#      255: special exit more 'q'
 
 SERVER="$1"
 SELECTOR="$2"
 PORT="$3"
 MODE="$4"
 
+PREFIX="[0-9hIg+]"
+
 # Defaults:
 [ "$PORT" = "" ] && PORT=70
 if [ "$MODE" = "" ]; then
        # "" or dir-like selector? -> 1 ; if not -> 0 
        echo "$SELECTOR" | grep "/$" >/dev/null && MODE=1 || MODE=0
        [ "$SELECTOR" = "" ] && MODE=1
+       
+       # check explicit modes:
+       if echo "$SELECTOR" | grep "^/\($PREFIX\|download\)/" >/dev/null; then
+               MODE="`echo "$SELECTOR" | cut -f2 -d/`"
+               SELECTOR="`echo "$SELECTOR" | sed 's:^/[^/]*/::'`"
+       fi
 fi
 
 if [ "$SERVER" = "" ]; then
        echo "Syntax error: $0 [SERVER] ([SELECTOR]) ([PORT]) ([MODE])" >&2
-       exit 2
+       exit 1
 fi
 
 # can be "-" for no escape sequences
@@ -60,7 +82,12 @@ if [ "$USE_DIALOG" = "" ]; then
        fi
 fi
 
-PREFIX="[0-9hIg]"
+# Invert image viewer
+if [ "$INVERT" = 1 ]; then
+       INVERT="--invert"
+else
+       INVERT=
+fi
 
 # $0 [FILE] (dialog)
 # Display a gopher menu for the given resource
@@ -116,10 +143,14 @@ finish() {
 }
 trap finish EXIT
 
+echo "$SELECTOR" | nc "$SERVER" "$PORT" > "$tmp"
+if [ $? != 0 ]; then
+       echo Cannot contact gopher server "[$SERVER]" >&2
+       exit 2
+fi
+
 if [ $MODE = 1 ]; then
-       echo "$SELECTOR" | nc "$SERVER" "$PORT" | sed 's:\r::g' > "$tmp"
-else
-       echo "$SELECTOR" | nc "$SERVER" "$PORT" > "$tmp"
+       sed --in-place 's:\r::g' "$tmp"
 fi
 
 # Process page content
@@ -132,7 +163,7 @@ download)
        cat "$tmp" | less
 ;;
 1|+)
-       CHOICE=start
+       CHOICE=0
        while [ "$CHOICE" != "" ]; do
                if [ "$USE_DIALOG" = 1 ]; then
                        > "$tmp.menu"
@@ -148,8 +179,9 @@ download)
                                --menu "$title" \
                                "$LINES" "$COLUMNS" "$LINES" \
                                --file "$tmp.menu" 2>"$tmp.choice"
-                       clear
                        val=$?
+                       clear
+                       
                        if [ $val = 3 ]; then
                                CHOICE=""
                        elif [ $val = 1 ]; then
@@ -162,7 +194,17 @@ download)
                        rm "$tmp.choice"
                else
                        cat_menu "$tmp" | less
-                       read -p "[$SELECTOR]: " CHOICE
+                       read -p "[$SELECTOR]: " NEW_CHOICE
+                       if [ "$NEW_CHOICE" = p ]; then
+                               CHOICE=`expr "$CHOICE" - 1 2>/dev/null`
+                               if [ "$CHOICE" -lt 0 ]; then
+                                       CHOICE=`cat "$tmp" | grep "^$PREFIX" | wc --lines`
+                               fi
+                       elif [ "$NEW_CHOICE" = n ]; then
+                               CHOICE=`expr "$CHOICE" + 1 2>/dev/null`
+                       else
+                               CHOICE="$NEW_CHOICE"
+                       fi
                fi
                
                [ "$CHOICE" = q ] && exit 255 # force-quit
@@ -172,6 +214,7 @@ download)
                        goto_sel="`getsel "$tmp" $index 2`"
                        goto_port="`getsel "$tmp" $index 4`"
                        goto_mode="`getsel "$tmp" $index 1 | cut -c1`"
+                       echo "Digging to [$goto_server:$goto_port] $index [$goto_sel]..."
                        sh "$0" "$goto_server" "$goto_sel" "$goto_port" "$goto_mode"
                        [ $? = 255 ] && exit 255 # force-quit
                fi
@@ -193,11 +236,13 @@ download)
 g|I)
        if img2aa --help >/dev/null 2>&1; then
                img2aa --mode=DITHERING \
+                       $INVERT \
                        --width=74 "$tmp" | less
        elif jp2a -h >/dev/null 2>&1; then
                if convert -h >/dev/null 2>&1; then
                        convert "$tmp" "$tmp.jpg"
                        jp2a --border --chars=" .-+=o8#"\
+                               $INVERT \
                                --width=74 "$tmp.jpg" | less
                else
                        echo "required program not found to view images: convert" \